<?php
/* 
   Copyright 2003, 2004 John Rankin john.rankin@affinity.co.nz

   This file turns a trail page into a published book of the contents, in a
   form suitable for printing. Adds a Printable Version to each browse page.

*/
if ($action=="print" || $action=="publish") {
    $EnablePrint = 0;
    $PageTemplateFmt = 'pub/skins/publish/print.tmpl';
    $PageCSSListFmt = array('pub/css/local.css' => '$PubDirUrl/css/local.css');
    $LastModified = strftime($TimeFmt,$Now);
    $ActionDescription = ($action=='print') ? 'last modified' : 'collection published';
    $GroupHeaderFmt = '$Group.GroupPrintHeader';
    $GroupFooterFmt = '$Group.GroupPrintFooter';
    $DoubleBrackets["/\\[\\[mailto:($UrlPathPattern)(.*?)\\]\\]/e"] =
      'Addressee("$2") ." [[[mailto:$1 $1]]]";';
    $WikiPageExistsFmt = 
      "<a class='wikiword' href='\$PageUrl?action=print'>\$LinkText</a>";
    $WikiPageCreateFmt = 
      "<a class='nonexistent' href='\$PageUrl?action=print'>\$LinkText</a>";
    $WikiPageCreateSpaceFmt =
      "<a class='nonexistent' href='\$PageUrl?action=print'>\$LinkText</a>";
    $UrlLinkTextFmt = "<cite>\$LinkText</cite> [<b>\$Url</b>]";
    $FmtUrlLink = 'FmtUrlLinkPublish';
    $TrailLinkPattern = 
      "(?:($GroupNamePattern)([\\/.]))?(($WikiWordPattern)|($FreeLinkPattern))";
    $DoubleBrackets["/&lt;&lt;\\|($TrailLinkPattern)\\|&gt;&gt;/"] = "$1";
    $DoubleBrackets["/\\^\\|($TrailLinkPattern)\\|\\^/"] = '';
    $DoubleBrackets["/&lt;\\|($TrailLinkPattern)\\|&gt;/"] = '';
    $InlineReplacements['/\\[\\[\\$Publish(.*?)\\]\\]/'] = '';
    $SpaceWikiWords = 2;
    $hide = 1;
} 
$needle = $HTTP_GET_VARS['needle'];
if (isset($needle)) {
    SDV($HandleActions['publish'],'HandleSearchPublish');
    $haystack = $HTTP_GET_VARS['haystack'];
    $pagearray = $HTTP_GET_VARS['pagearray'];
    $PrintHeaderFmt = 'Selected Search Results';
    $SearchForFmt = "<h4>$[SearchFor]</h4>";
} else {
    SDV($HandleActions['publish'],'HandlePublish');
    $include = $HTTP_GET_VARS['include'];
    $PrintHeaderFmt = "<a class='wikiword' href='\$PageUrl?action=print'>\$Group: \$Titlespaced</a>";
    $SearchForFmt = '';
}
SDV($HandlePublishFmt,array(&$PageStartFmt,
                            "wiki:$GroupHeaderFmt",
                            &$PublishList,
                            "wiki:$GroupFooterFmt",
                            &$PageEndFmt));
SDV($PublishPageNotFoundFmt,'Page \'\'$Tlink\'\' does not exist.');
SDV($PublishPageNameFmt,"<a class='wikiword' href='\$PageUrl'>\$Titlespaced</a>:");
SDV($PublishTagFmt,"<form class='publish' target='_blank' action='\$PageUrl' method='get'>
    \$PublishName<input type='hidden' name='action' value='publish' />
    <input type='checkbox' name='include' value='include' />$[Include this page]
    <input type='submit' value='$[Publish]' /></form>");
SDV($InlineReplacements['/\\[\\[\\$Publish(nodate)?(:(.*?))?\\]\\]/e'],
   "FmtPublishName(\$GLOBALS['PublishTagFmt'],\$pagename,'\$3')");
$DoubleBrackets['/\\[\\[\\$Publish:(.*?)\\]\\]/e'] =
   'ValidatePublish("$pagename","$1");';
if (!isset($IncludeModifiedDate)) $IncludeModifiedDate = true;

function ValidatePublish($pagename,$publishpage) {
  global $GroupNamePattern,$PageTitlePattern;
  $delimiter = '/';
  if (preg_match("/^$GroupNamePattern([\\/.])$PageTitlePattern\$/",
      $publishpage,$match))
      $delimiter = $match[1];
  else
      $publishpage = FmtPageName('$Group',$pagename)."/$publishpage";
  if (PageExists($publishpage)) return "[[\$Publish:" . AsSpaced($publishpage) . "]]";
  else return str_replace($delimiter,"$delimiter{{",$publishpage) . "}} not found.";
}

function FmtPublishName($fmt,$pagename,$publishpage) {
  global $PublishPageNameFmt;
  if ($publishpage) {
     $publishpage = str_replace(" ","",$publishpage);
     $r = FmtPageName($PublishPageNameFmt,$publishpage);
  } else 
     $publishpage = $pagename;
  return str_replace('$PublishName',$r,FmtPageName($fmt,$publishpage));
}

function HandlePublish($pagename) {
  global $HandlePublishFmt,$TrailLinkPattern,$PublishPageNotFoundFmt;
  global $include,$HTMLTitle,$GCount,$IncludeModifiedDate;
  $trailname = FmtWikiLink('',$pagename,NULL,'PageName');
  $trailpage = ReadPage($trailname);
  if ($trailpage) {
    if (strstr($trailpage['text'],'[[$Publishnodate]]')) $IncludeModifiedDate = false;
    $trailgroup = FmtPageName('$Group',$trailname);
    foreach(explode("\n",$trailpage['text']) as $x) {
      if (preg_match("/^T?([#*:]+)\\s*(.*)/",$x,$match)) {
          $match[1] = str_replace(':#',':',$match[1]);
          $depth[] = strlen($match[1]);
          if (preg_match("/^(\\[\\[)?($TrailLinkPattern)/",$match[2],$text)) {
              $pg = (preg_match('![./]!',$text[2])) ? $text[2] :
                                                      $trailgroup.'/'.$text[2];
              $pages[] = FmtWikiLink('',$pg,NULL,'PageName',$trailname);
              if (preg_match("/^\\[\\[($TrailLinkPattern)((?:\\s.*?)\\]\\])/",
                               $match[2],$dbm))
                  $links[] = "[[".$pg.array_pop($dbm);
              else
                  $links[] = $pg;
          } elseif (!strstr($match[1],":")) {
              $pages[] = "textonly";
              $links[] = $match[2];
          }
      }
    }
    if (isset($include)) {
        $PublishList[] = "function:PrintThisPage $pagename";
    }
    for($i=0;$i<count($pages);$i++) {
      $counter[$depth[$i]-1]++;
      $num = $counter[0];
      for($j=$depth[$i];$j<$predepth;$j++) $counter[$j] = 0;
      $predepth = $depth[$i];
      $size = 0;
      for($j=1;$j<$depth[$i];$j++) { $num .= "." . $counter[$j]; $size++; }
      if ($size>3) $size=3;
      $s = str_repeat('-',$size);
      if ($size==0) $PublishList[] = "function:PrintText !$num $links[$i]";
      else $PublishList[] = "function:PrintText ![$s$num $links[$i]$s]";
      if ($pages[$i]!="textonly") {
          if (PageExists($pages[$i])) 
		$PublishList[] = "function:PrintThisPage $pages[$i]";
          else {
              if (preg_match("/\\[\\[($TrailLinkPattern)\\s+/",$links[$i],$m)) {
                 $alias=str_replace("]]",")",str_replace($m[0],"(",$links[$i]));
                 $replname = "$m[1] $alias";
              } else $replname = $links[$i];
              $PublishList[] = 
                  "function:PrintText " . 
                  str_replace('$Tlink',$replname,$PublishPageNotFoundFmt);
          }
      }
    }
  }
  $GLOBALS['PublishList'] = $PublishList;
  $HTMLTitle = "Publish $pagename"; $GCount = 0;
  PrintFmt($pagename,$HandlePublishFmt);
}

function HandleSearchPublish($pagename) {
  global $HandlePublishFmt,$HTMLTitle,$GCount;
  global $needle,$haystack,$pagearray;
  for($i=0;$i<count($pagearray);$i++) {
    $page = str_replace('/','/{{',$pagearray[$i]) . "}}";
    $PublishList[] = "function:PrintText !$page";
    $PublishList[] = "function:PrintThisPage $pagearray[$i]";
  }
  if (count($pagearray)==0) $PublishList[] = "<h3>$[No pages selected]</h3>";
  $GLOBALS['PublishList'] = $PublishList;
  $GLOBALS['Needle'] = $needle;
  $GLOBALS['Haystack'] = $haystack;
  $HTMLTitle = "Publish Search"; $GCount = 0;
  PrintFmt($pagename,$HandlePublishFmt);
}

function NeedleAndHaystack($pagename) {
  global $SearchIncl,$SearchExcl,$SearchGroup;
  global $Needle,$Haystack;
  if ($SearchGroup) { $Haystack = "&lsquo;$SearchGroup&rsquo; group"; }
  else { $Haystack = 'all groups'; }
  $n = str_replace('$LQ$RQ',"",'$LQ'.join('$RQ and $LQ',$SearchIncl).'$RQ');
  foreach($SearchExcl as $w) { $n .= " not \$LQ$w\$RQ"; }
  if ($n) $Needle = str_replace('$LQ','&lsquo;',
                    str_replace('$RQ','&rsquo;',htmlspecialchars(trim($n))));
  else $Needle = 'all';
}

function PrintThisPage($pagename,$wikipage=NULL) {
  global $IncludeModifiedDate;
  if (is_null($wikipage)) $wikipage=$pagename;
  if (PageExists($wikipage)) {
    $page = RetrieveAuthPage($wikipage,"read",false);
    $GLOBALS['pagename'] = $wikipage;
    SetInterMapUrls($wikipage);
    PrintText($wikipage,PrepareText($wikipage,$page['text']));
    if ($IncludeModifiedDate) PrintText($wikipage,"\n\n(".$page['timefmt'].")");
    $GLOBALS['pagename'] = $pagename;
  }
}

function SetInterMapUrls($page) {
  global $UploadUrlFmt,$UploadPrefixFmt,$InterMapUrls;
  $InterMapUrls['Attach'] = 
        FmtPageName("$UploadUrlFmt$UploadPrefixFmt$1",$page);
}

function PrepareText($pagename,$text) {
  global $GroupNamePattern,$PageTitlePattern,$MaxIncludes,$BrowseDirectives;
  $inclcount=0;
  while ($inclcount<$MaxIncludes &&
      preg_match("/\\[\\[include:(.*?)\\]\\]/",$text,$match)) {
    $inclrepl=$match[0]; $inclname=$match[1]; $incltext='';
    if (!preg_match("/^$GroupNamePattern([\\/.])$PageTitlePattern\$/",
        $inclname))
      $inclname = FmtPageName('$Group',$pagename).".$inclname";
    $inclpage = RetrieveAuthPage($inclname,"read",false);
    if ($inclpage) $incltext=$inclpage['text'];
    $text = str_replace($inclrepl,$incltext,$text);
    $inclcount++;
  }
  Lock(0);
  foreach($BrowseDirectives as $p=>$s) {
    if (strstr($text,$p)) $text = str_replace($p,eval($s),$text);
  }
  return $text;
}

function PrintEndnotes($pagename,$urltext) {
  $etext = Endnote($urltext);
  if ($etext!="") PrintText($pagename,$etext);
}

function Endnote($urltext) {
  static $endcount, $endtext;
  if ($urltext == "#") {
     $r = "$endtext";
     if ($endcount>0) $r = "!Links\n$r";
     $endcount = 0;
     $endtext = '';
  } else {
     $endcount++;
     $r = "<b><a href='#end$endcount'>$endcount</a></b>";
     $urltext = str_replace('&amp;','&',stripslashes($urltext));
     $endtext .= "# [[#end$endcount]]$urltext\n";
  }
  return $r;
}

function FmtUrlLinkPublish($pat,$ref,$btext) {
  if (!is_null($btext)) { $ref = Endnote($ref); }
  return FmtUrlLink($pat,$ref,$btext);
}

function Addressee($name) {
  global $WikiWordPattern;
  $r = preg_replace("/($WikiWordPattern)/","`$1",$name);
  return "''$r''";
}

?>
